#ifndef _SILECS_DEPLOY_H_
#define _SILECS_DEPLOY_H_

#include <silecs-communication/interface/equipment/SilecsDesign.h>
#include <silecs-communication/interface/communication/SilecsConnection.h>
#include <silecs-communication/interface/equipment/SilecsParamConfig.h>

#include <functional>
#include <vector>
#include <string>

namespace Silecs
{

class SilecsDeploy
{
public:
    SilecsDeploy() = default;
    SilecsDeploy(const std::string& paramFile, Connection& plcConnection, const SilecsParamConfig& paramConfig);

    const Device& getHeader() const;

    const std::vector<SilecsDesign>& getDesigns() const;

    SilecsDesign& getDesign(const std::string& designName);

    void withAllDesigns(const std::function<void(SilecsDesign&)>& callable);

    void withDesign(const std::string& designName, const std::function<void(SilecsDesign&)>& callable);

private:
    std::vector<SilecsDesign> designs_;
};

} // namespace Silecs

#endif // _SILECS_DEPLOY_H_